<?php
class YuniccBaseClass
{
	public function RenderTimeAgo($property)
	{
		global $locale;
		
		$variable_name = "s{$property}";
		
		if(isset($this->$variable_name) && is_numeric($this->$variable_name))
		{
			$timestamp = $this->$variable_name;
			
			if($timestamp > time())
			{
				$return_string = $locale->strings['event-future'];
			}
			elseif($timestamp == time())
			{
				$return_string = $locale->strings['event-now'];
			}
			else
			{
				$date1 = new DateTime("@{$timestamp}", new DateTimeZone("GMT"));
				$date2 = new DateTime("now", new DateTimeZone("GMT"));
				
				$interval = $date1->diff($date2);
				$years = (int)$interval->format("%G"); 
				$months = (int)$interval->format("%m"); 
				$weeks = (int)$interval->format("%U"); 
				$days = (int)$interval->format("%d"); 
				$hours = (int)$interval->format("%H");
				$minutes = (int)$interval->format("%i");
				$seconds = (int)$interval->format("%S");
				
				/*var_dump($interval);
				
				var_dump($years);
				var_dump($months);
				var_dump($weeks);
				var_dump($days);
				var_dump($hours);
				var_dump($minutes);
				var_dump($seconds);*/
				
				if($years > 1)
				{
					$return_string = sprintf($locale->strings['event-years-ago'], $years);
				}
				elseif($years == 1)
				{
					$return_string = $locale->strings['event-1year-ago'];
				}
				elseif($months > 1)
				{
					$return_string = sprintf($locale->strings['event-months-ago'], $months);
				}
				elseif($months == 1)
				{
					$return_string = $locale->strings['event-1month-ago'];
				}
				elseif($weeks > 1)
				{
					$return_string = sprintf($locale->strings['event-weeks-ago'], $weeks);
				}
				elseif($weeks == 1)
				{
					$return_string = $locale->strings['event-1week-ago'];
				}
				elseif($days > 1)
				{
					$return_string = sprintf($locale->strings['event-days-ago'], $days);
				}
				elseif($days == 1)
				{
					$return_string = $locale->strings['event-1day-ago'];
				}
				elseif($hours > 1)
				{
					$return_string = sprintf($locale->strings['event-hours-ago'], $hours);
				}
				elseif($hours == 1)
				{
					$return_string = $locale->strings['event-1hour-ago'];
				}
				elseif($minutes > 1)
				{
					$return_string = sprintf($locale->strings['event-minutes-ago'], $minutes);
				}
				elseif($minutes == 1)
				{
					$return_string = $locale->strings['event-1minute-ago'];
				}
				elseif($seconds > 1)
				{
					$return_string = sprintf($locale->strings['event-seconds-ago'], $seconds);
				}
				elseif($seconds == 1)
				{
					$return_string = $locale->strings['event-1second-ago'];
				}
				else
				{
					// If you see this, there's probably something wrong.
					$return_string = $locale->strings['event-past'];
				}
				
			}
			
			return $return_string;
		}
		else
		{
			$classname = get_class($this);
			throw new Exception("Property {$classname}.{$property} does not exist or is not of a valid format.");
		}
	}
}
?>
