<?php
class StreamEvent extends YuniccDatabaseRecordClass
{
	public $sId = 0;
	public $sCommunityId = 0;
	public $sUserId = 0;
	public $sSection = 0;
	public $sType = 0;
	public $sItemId = 0;
	public $sUrl = "";
	public $sTitle = "";
	public $sDate = 0;
	
	public function __construct($uDataSource)
	{
		if(is_numeric($uDataSource))
		{
			$this->sId = (is_numeric($uDataSource)) ? $uDataSource : 0;
			
			$query = "SELECT * FROM events WHERE `Id` = '{$this->sId}'";
			if($result = mysql_query_cached($query))
			{
				$uDataSource = $result->data[0];
			}
			else
			{
				throw new Exception("Could not locate StreamEvent in database.");
			}
		}
		elseif(is_object($uDataSource))
		{
			if(isset($uDataSource->data[0]))
			{
				$uDataSource = $uDataSource->data[0];
			}
			else
			{
				throw new Exception("No result set present in object.");
			}
		}
		elseif(is_array($uDataSource))
		{
			if(isset($uDataSource[0]))
			{
				$uDataSource = $uDataSource[0];
			}
		}
		else
		{
			throw new Exception("Invalid type passed on to constructor.");
		}
		
		$this->sId = (is_numeric($uDataSource['Id'])) ? $uDataSource['Id'] : 0;
		
		$this->sCommunityId = 	(is_numeric($uDataSource['ClubId'])) ? 	$uDataSource['ClubId'] : 0;
		$this->sUserId = 		(is_numeric($uDataSource['UserId'])) ? 	$uDataSource['UserId'] : 0;
		$this->sItemId = 		(is_numeric($uDataSource['ItemId'])) ? 	$uDataSource['ItemId'] : 0;
		$this->sSection = 		(is_numeric($uDataSource['Section'])) ? $uDataSource['Section'] : 0;
		$this->sType = 			(is_numeric($uDataSource['Type'])) ? 	$uDataSource['Type'] : 0;
		$this->sUrl =			htmlspecialchars(stripslashes($uDataSource['Url']));
		$this->sTitle =			htmlspecialchars(stripslashes($uDataSource['Title']));
		$this->sDate =			unix_from_mysql($uDataSource['Date']);
	}
	
	public function Render()
	{
		// Takes no arguments.
		// Returns a page-safe string.

		global $locale;

		if(!empty($this->sCommunityId) && !empty($this->sUserId) && !empty($this->sSection) && !empty($this->sType))
		{
			$sUser = new User($this->sUserId);
			$sUserDisplayName = htmlspecialchars(stripslashes($sUser->uDisplayName));
			$sStringAction = "";
			
			switch($this->sSection)
			{
				case YUNICC_EVENT_SECTION_HOME:
					switch($this->sType)
					{
						case YUNICC_EVENT_TYPE_ADD_ITEM:
							$sStringAction = $locale->strings['event-home-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_ITEM:
							$sStringAction = $locale->strings['event-home-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_ITEM:
							$sStringAction = $locale->strings['event-home-edited'];
							break;
						case YUNICC_EVENT_TYPE_MOVE_ITEM:
							$sStringAction = $locale->strings['event-home-reordered'];
							break;
						default:
							throw new Exception("Invalid StreamEvent.Type property.");
							break;
					}
					break;
				case YUNICC_EVENT_SECTION_NEWS:
					switch($this->sType)
					{
						case YUNICC_EVENT_TYPE_ADD_ITEM:
							$sStringAction = $locale->strings['event-news-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_ITEM:
							$sStringAction = $locale->strings['event-news-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_ITEM:
							$sStringAction = $locale->strings['event-news-edited'];
							break;
						case YUNICC_EVENT_TYPE_MOVE_ITEM:
							$sStringAction = $locale->strings['event-news-moved'];
							break;
						case YUNICC_EVENT_TYPE_REPLY_ITEM:
							$sStringAction = $locale->strings['event-news-commented'];
							break;
						case YUNICC_EVENT_TYPE_ADD_CATEGORY:
							$sStringAction = $locale->strings['event-news-category-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_CATEGORY:
							$sStringAction = $locale->strings['event-news-category-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_CATEGORY:
							$sStringAction = $locale->strings['event-news-category-edited'];
							break;
						default:
							throw new Exception("Invalid StreamEvent.Type property.");
							break;
					}
					break;
				case YUNICC_EVENT_SECTION_PICTURES:
					switch($this->sType)
					{
						case YUNICC_EVENT_TYPE_ADD_ITEM:
							$sStringAction = $locale->strings['event-pictures-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_ITEM:
							$sStringAction = $locale->strings['event-pictures-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_ITEM:
							$sStringAction = $locale->strings['event-pictures-edited'];
							break;
						case YUNICC_EVENT_TYPE_MOVE_ITEM:
							$sStringAction = $locale->strings['event-pictures-moved'];
							break;
						case YUNICC_EVENT_TYPE_REPLY_ITEM:
							$sStringAction = $locale->strings['event-pictures-commented'];
							break;
						case YUNICC_EVENT_TYPE_ADD_CATEGORY:
							$sStringAction = $locale->strings['event-pictures-category-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_CATEGORY:
							$sStringAction = $locale->strings['event-pictures-category-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_CATEGORY:
							$sStringAction = $locale->strings['event-pictures-category-edited'];
							break;
						default:
							throw new Exception("Invalid StreamEvent.Type property.");
							break;
					}
					break;
				case YUNICC_EVENT_SECTION_FORUM:
					switch($this->sType)
					{
						case YUNICC_EVENT_TYPE_ADD_ITEM:
							$sStringAction = $locale->strings['event-forum-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_ITEM:
							$sStringAction = $locale->strings['event-forum-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_ITEM:
							$sStringAction = $locale->strings['event-forum-edited'];
							break;
						case YUNICC_EVENT_TYPE_MOVE_ITEM:
							$sStringAction = $locale->strings['event-forum-moved'];
							break;
						case YUNICC_EVENT_TYPE_REPLY_ITEM:
							$sStringAction = $locale->strings['event-forum-commented'];
							break;
						case YUNICC_EVENT_TYPE_ADD_CATEGORY:
							$sStringAction = $locale->strings['event-forum-category-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_CATEGORY:
							$sStringAction = $locale->strings['event-forum-category-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_CATEGORY:
							$sStringAction = $locale->strings['event-forum-category-edited'];
							break;
						default:
							throw new Exception("Invalid StreamEvent.Type property.");
							break;
					}
					break;
				case YUNICC_EVENT_SECTION_FILES:
					switch($this->sType)
					{
						case YUNICC_EVENT_TYPE_ADD_ITEM:
							$sStringAction = $locale->strings['event-files-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_ITEM:
							$sStringAction = $locale->strings['event-files-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_ITEM:
							$sStringAction = $locale->strings['event-files-edited'];
							break;
						case YUNICC_EVENT_TYPE_MOVE_ITEM:
							$sStringAction = $locale->strings['event-files-moved'];
							break;
						case YUNICC_EVENT_TYPE_REPLY_ITEM:
							$sStringAction = $locale->strings['event-files-commented'];
							break;
						case YUNICC_EVENT_TYPE_ADD_CATEGORY:
							$sStringAction = $locale->strings['event-files-category-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_CATEGORY:
							$sStringAction = $locale->strings['event-files-category-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_CATEGORY:
							$sStringAction = $locale->strings['event-files-category-edited'];
							break;
						default:
							throw new Exception("Invalid StreamEvent.Type property.");
							break;
					}
					break;
				case YUNICC_EVENT_SECTION_VIDEO:
					switch($this->sType)
					{
						case YUNICC_EVENT_TYPE_ADD_ITEM:
							$sStringAction = $locale->strings['event-video-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_ITEM:
							$sStringAction = $locale->strings['event-video-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_ITEM:
							$sStringAction = $locale->strings['event-video-edited'];
							break;
						case YUNICC_EVENT_TYPE_MOVE_ITEM:
							$sStringAction = $locale->strings['event-video-moved'];
							break;
						case YUNICC_EVENT_TYPE_REPLY_ITEM:
							$sStringAction = $locale->strings['event-video-commented'];
							break;
						case YUNICC_EVENT_TYPE_ADD_CATEGORY:
							$sStringAction = $locale->strings['event-video-category-added'];
							break;
						case YUNICC_EVENT_TYPE_DELETE_CATEGORY:
							$sStringAction = $locale->strings['event-video-category-deleted'];
							break;
						case YUNICC_EVENT_TYPE_EDIT_CATEGORY:
							$sStringAction = $locale->strings['event-video-category-edited'];
							break;
						default:
							throw new Exception("Invalid StreamEvent.Type property.");
							break;
					}
					break;
				default:
					throw new Exception("Invalid StreamEvent.Section property.");
					break;
			}
			
			if(!empty($this->sUrl))
			{
				$sHref = "<strong><a href=\"#{$this->sUrl}\">{$this->sTitle}</a></strong>";
			}
			else
			{
				$sHref = "<strong>{$this->sTitle}</strong>";
			}
			
			$sString = "<a href=\"#\" onclick=\"lookup_user({$this->sUserId}); return false;\">{$sUserDisplayName}</a> " . vsprintf($sStringAction, array(
				$sHref
			));
			
			return $sString;
		}
		else
		{
			throw new Exception("StreamEvent object missing vital properties.");
		}
	}
}
?>
